<?php
    session_start();
    
    // Imports da biblioteca phpowl:
    require_once "./phpowl/OWLReader.php";  
    if(isset($_GET['visualize'])){
        $_SESSION['ontology'] = $_GET['path'];
   }
   if(isset($_GET['erase'])){
       if($_GET['erase']==1){
        $_SESSION['ontology'] = $_GET['path'];  
       }
   }
?>

<html>
    <?php
        // Guardar o tempo actual para mostrar o tempo necessrio para gerar a pgina:
        $startTime = explode(' ', microtime());
        $startTime = $startTime[1] + $startTime[0];
    ?>
    
    <!-- HTML CSS Definitions -->
    <head>
        <link rel="stylesheet" type="text/css" href="css/style.css" /> 
        <style type="text/css"></style>
        <title>Ontology Navigator</title>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
        
        <!-- Script para "fazer scroll" para a descrio da classe caso tenha sido seleccionada uma. -->
        <script language="javascript">
            function position() { if('<?php echo $_GET['class'] ?>'.length > 0) window.location = '#marker'; }
        </script>
    </head>
    
    <!-- BODY -->
    <body onLoad="javascript:position()">
        <div align="center">
            <a href="index.php"> <img border="0" height="25%" alt="OWL Navigator" src="images/logo6.png"/></a>
            <br/><br/>
            <br style="font-size:50%;"/>  
                <a name="marker"></a>
            <br style="font-size:50%;"/>
            <table class="main"> 
                <tr>
                    <th><a href="overview.php">Viso Geral</a></th>
                    <th class="open">Classes</th>
                    <th><a href="object_prop.php">Propriedades de Objecto</a></th> 
                    <th><a href="individuals.php">Indivduos</a></th>
                </tr>
                <tr>
                    <td class="separator" colspan="4">
                        <table class="separator" width="100%">
                            <tr>
                                <td class="left" align="center" valign="top" width="33%"><?php printClassHierarchy();?></td>
                                <td class="right" align="center" valign="top" width="67%"><?php printClassInfo();?></td>
                            </tr>
                        </table>
                    </td>
                </tr>         
            </table>
            
            <br/><br/>
            <h5 class="about">
                <?php
                    // Mostrar quanto tempo esta pgina demorou a gerar:
                    $currentTime = explode(' ', microtime());
                    $totalTime = $currentTime[0] + $currentTime[1] - $startTime;
                    printf('Gerado em %.3fs', $totalTime);
                ?>
                <br />
                &copy;2010 - <a href="about.html">Acerca</a>
            </h5>
        </div>
    </body>
</html>



<?php

    // Mostra a hieraquia de classes
    function printClassHierarchy()
    {
         global $ontology;
         global $reader;
         $ontology = new OWLOntology();
         $reader = new OWLReader();
         $reader->loadFromFile($_SESSION['ontology'], $ontology);
         $reader->inferClassHierarchy($ontology);
         
         print "<table class='secondary' width='100%' height='100%' align='center' bordercolor=#CC9F2A>";
            print "<tr>";
                print "<td bgcolor='#CC9F2A'>";
                    print "<b style='color:white'>Hierarquia de classes</b>";
                print "</td>";
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                    print "<ul>";
                        recursivePrint($ontology, $ontology->getThingClassURI());
                    print "</ul>";
                    print "<br/><b>Total: </b>" . count($ontology->getClassURIs());
                    print "<br/>";
                print "</td>";                
            print "</tr>";                   
        print "</table>";               
    }
    
    
    
    // Imprime a hierarquia de classes recursivamente:
    function recursivePrint(&$ontology, $classURI)
    {
        // Obter o objecto PHP da classe:
        $class = $ontology->getClass($classURI);
        
        // Mostrar dados da classe actual:
        if($class == null) return;
        else
        {
            $string = " href=classes.php?class=" . utf8_decode($class->getLabel()) .
                  ">" . utf8_decode($class->getLabel()) . "</a>";
            
            // Realar caso esteja seleccionada:
            if(strcmp(utf8_decode($class->getLabel()), $_GET['class']) == 0)
                $string = "<a class='highlight'" . $string;
            else $string = "<a" . $string;
            
            // Meter a negrito se esta no tiver subclasses:
            if(count($class->getSubClassURIs()) > 0) print "<li>" . $string . "</li>";
            else print "<li><b>" . $string . "</b></li>";
        }
        
        // Percorrer as subclasses desta:
        foreach($class->getSubClassURIs() as $nextURI)
        {
            print "<ul>";
            recursivePrint($ontology, $nextURI);
            print "</ul>";
        }
    }
    
    
    
    // Criar formulrio para mostrar informao das classes:
    function printClassInfo()
    {
        // Inicializar as variveis todas necessrias:
        global $ontology;
        global $reader;
        $classURI = "";
        $classLabel = "";
        $subClasses = Array();
        $superClasses = Array();
        $members = Array();

        // Definir as variveis, caso a classe seja vlida:
        if($_GET['class'])
        {
            // Obter o objecto desta classe:
            if(strcmp($_GET['class'], "Thing") == 0)
                $class = $ontology->getClass($ontology->getThingClassURI());
            else $class = $ontology->getClass($ontology->getNamespace() . utf8_encode($_GET['class']));
            
            if($class != null)
            {
                // Inferir membros:
                $reader->inferClassMembers($ontology);
                
                // Atribuir variveis:
                $classURI = $class->getURI();
                $classLabel = $class->getLabel();
                $subClasses = $class->getSubClassURIs();
                $superClasses = $class->getSuperClassURIs();
                $members = $class->getMemberURIs();
            }
        }
        
        // Mostrar todos os dados:
        print "<table width='100%' height='100%' class='secondary' bordercolor=#CC9F2A>";
            print "<tr>";
                print "<td bgcolor='#CC9F2A'>";   
                    print "<b style='color:white'>Descrio: " . utf8_decode($classLabel) . "</b>";
                print "</td>";
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                    print "<b>URI: </b><br/><div class='indent'>" . utf8_decode($classURI) . "</div><br/>";
                    print "<b>Superclasses: </b><br/><div class='indent'>";
                        foreach($superClasses as $superClassURI)
                        {
                            $superClass = $ontology->getClass($superClassURI);
                            print "<a href='classes.php?class=" . utf8_decode($superClass->getLabel()) . "'>" .
                                  utf8_decode($superClass->getLabel()) . "</a><br/>";
                        }
                        print "</div><br/>";
                    print "<b>Subclasses: </b><br/><div class='indent'>";
                        foreach($subClasses as $subClassURI)
                        {
                            $subClass = $ontology->getClass($subClassURI);
                            print "<a href='classes.php?class=" . utf8_decode($subClass->getLabel()) . "'>" .
                                  utf8_decode($subClass->getLabel()) . "</a><br/>";
                        }
                        print "</div><br/>";
                    print "<b>Membros: </b><br/><div class='indent'>";
                        foreach($members as $memberURI)
                        {
                            $member = $ontology->getIndividual($memberURI);
                            print "<a href='individuals.php?indv=" . utf8_decode($member->getLabel()) . "'>" .
                                  utf8_decode($member->getLabel()) . "</a><br/>";
                        }
                        print "</div><br/>";
                print "</td>";
            print "</tr>";
        print "</table>";
    }
?>