<?php
    session_start();
    
    // Imports da biblioteca phpowl:
    require_once "./phpowl/OWLReader.php";  
    if(isset($_GET['visualize'])){
        $_SESSION['ontology'] = $_GET['path'];
   }
   if(isset($_GET['erase'])){
       if($_GET['erase']==1){
        $_SESSION['ontology'] = $_GET['path'];  
       }
   }
?>

<html>
    <?php
        // Guardar o tempo actual para mostrar o tempo necessrio para gerar a pgina:
        $startTime = explode(' ', microtime());
        $startTime = $startTime[1] + $startTime[0];
    ?>
    
    <!-- HTML CSS Definitions -->
    <head>
        <link rel="stylesheet" type="text/css" href="css/style.css" /> 
        <style type="text/css"></style>
        <title>Ontology Navigator</title>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
        
        <!-- Script para "fazer scroll" para a descrio do indivduo caso tenha sido seleccionada uma. -->
        <script language="javascript">
            function position() { if('<?php echo $_GET['indv'] ?>'.length > 0) window.location = '#marker'; }
        </script>
    </head>
    
    <!-- BODY -->
    <body onLoad="javascript:position()">
        <div align="center">
            <a href="index.php"> <img border="0" height="25%" alt="OWL Navigator" src="images/logo6.png"/></a>
            <br/><br/>
            <br style="font-size:50%;"/>  
                <a name="marker"></a>
            <br style="font-size:50%;"/>
            <table class="main"> 
                <tr>
                    <th><a href="overview.php">Viso Geral</a></th>
                    <th><a href="classes.php">Classes</a></th>
                    <th><a href="object_prop.php">Propriedades de Objecto</a></th> 
                    <th class="open">Indivduos</th>
                </tr>
                <tr>
                    <td class="separator" colspan="4">
                        <table class="separator" width="100%">
                            <tr>
                                <td class="left" align="center" valign="top" width="33%"><?php printIndividuals();?></td>
                                <td class="right" align="center" valign="top" width="67%"><?php printIndividualInfo();?></td>
                            </tr>
                        </table>
                    </td>
                </tr>         
            </table>
            
            <br/><br/>
            <h5 class="about">
                <?php
                    // Mostrar quanto tempo esta pgina demorou a gerar:
                    $currentTime = explode(' ', microtime());
                    $totalTime = $currentTime[0] + $currentTime[1] - $startTime;
                    printf('Gerado em %.3fs', $totalTime);
                ?>
                <br />
                &copy;2010 - <a href="about.html">Acerca</a>
            </h5>
        </div>
    </body>
</html>



<?php

    // Mostra a hieraquia de classes
    function printIndividuals() {
         global $ontology;
         global $reader;
         $ontology = new OWLOntology();
         $reader = new OWLReader();
         $reader->loadFromFile($_SESSION['ontology'], $ontology);
         
         print "<table class='secondary' width='100%' height='100%' align='center' bordercolor=#531852>";
            print "<tr>";
                print "<td bgcolor='#531852'>";
                    print "<b style='color:white'>Indivduos</b>";
                print "</td>";
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                    print "<ul>";
                        foreach($ontology->getIndividualURIs() as $individualURI)
                        {
                            // Obter o objecto actual:
                            $individual = $ontology->getIndividual($individualURI);
                            $string = " href=individuals.php?indv=" . utf8_decode($individual->getLabel()) .
                                  ">" . utf8_decode($individual->getLabel()) . "</a>";
                            
                            // Realar caso esteja seleccionada:
                            if(strcmp(utf8_decode($individual->getLabel()), $_GET['indv']) == 0)
                                $string = "<a class='highlight'" . $string;
                            else $string = "<a" . $string;
                            
                            print "<li>" . $string . "</li>";
                        }
                    print "</ul>";
                    print "<br/><b>Total: </b>" . count($ontology->getIndividualURIs());
                    print "<br/>";
                print "</td>";                
            print "</tr>";                   
        print "</table>";               
    }
    
    
    
    // Criar formulrio para mostrar informao dos indivduos:
    function printIndividualInfo()
    {
        // Inicializar as variveis todas necessrias:
        global $ontology;
        global $reader;
        $individualURI = "";
        $individualLabel = "";
        $types = Array();
        $assertions = Array();

        // Definir as variveis, caso o indivduo seja vlido:
        if($_GET['indv'])
        {
            // Obter o objecto desta classe:
            $individual = $ontology->getIndividual($ontology->getNamespace() . utf8_encode($_GET['indv']));
            
            if($individual != null)
            {
                // Inferir o necessrio:
                $reader->inferClassMembers($ontology);
                $reader->inferOPAssertions($ontology);
                
                // Atribuir variveis:
                $individualURI = $individual->getURI();
                $individualLabel = $individual->getLabel();
                $types = $individual->getTypeClassURIs();
                $assertions = $individual->getOPAssertionURIs();
            }
        }
        
        // Mostrar todos os dados:
        print "<table width='100%' height='100%' class='secondary' bordercolor=#531852>";
            print "<tr>";
                print "<td bgcolor='#531852'>";   
                    print "<b style='color:white'>Descrio: " . utf8_decode($individualLabel) . "</b>";
                print "</td>";
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                    print "<b>URI: </b><br/><div class='indent'>" . utf8_decode($individualURI) . "</div><br/>";
                    print "<b>Tipos: </b><br/><div class='indent'>";
                        foreach($types as $typeURI)
                        {
                            $class = $ontology->getClass($typeURI);
                            print "<a href='classes.php?class=" . utf8_decode($class->getLabel()) . "'>" .
                                  utf8_decode($class->getLabel()) . "</a><br/>";
                        }
                        print "</div><br/>";
                    print "<b>Asseres de propriedades de objecto: </b><br/><div class='indent'>";
                        foreach($assertions as $assertion)
                        {
                            $property = $ontology->getObjectProperty($assertion[0]);
                            $individual = $ontology->getIndividual($assertion[1]);
                            
                            print "<i><a href='object_prop.php?prop=" . utf8_decode($property->getLabel()) . "'>" .
                                  utf8_decode($property->getLabel()) . "</a></i> " .
                                  "<a href='individuals.php?indv=" . utf8_decode($individual->getLabel()) . "'>" .
                                  utf8_decode($individual->getLabel()) . "</a><br/>";
                        }
                        print "</div><br/>";
                print "</td>";
            print "</tr>";
        print "</table>";
    }
?>