<?php
    session_start();
    
    // Imports da biblioteca phpowl:
    require_once "./phpowl/OWLReader.php";  
    if(isset($_GET['visualize'])){
        $_SESSION['ontology'] = $_GET['path'];
   }
   if(isset($_GET['erase'])){
       if($_GET['erase']==1){
        $_SESSION['ontology'] = $_GET['path'];  
       }
   }
?>

<html>
    <?php
        // Guardar o tempo actual para mostrar o tempo necessrio para gerar a pgina:
        $startTime = explode(' ', microtime());
        $startTime = $startTime[1] + $startTime[0];
    ?>
    
    <!-- HTML CSS Definitions -->
    <head>
        <link rel="stylesheet" type="text/css" href="css/style.css" /> 
        <style type="text/css"></style>
        <title>Ontology Navigator</title>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
        
        <!-- Script para "fazer scroll" para a descrio da propriedade caso tenha sido seleccionada uma. -->
        <script language="javascript">
            function position() { if('<?php echo $_GET['prop'] ?>'.length > 0) window.location = '#marker'; }
        </script>
    </head>
    
    <!-- BODY -->
    <body onLoad="javascript:position()">
        <div align="center">
            <a href="index.php"> <img border="0" height="25%" alt="OWL Navigator" src="images/logo6.png"/></a>
            <br/><br/>
            <br style="font-size:50%;"/>  
                <a name="marker"></a>
            <br style="font-size:50%;"/>
            <table class="main"> 
                <tr>
                    <th><a href="overview.php">Viso Geral</a></th>
                    <th><a href="classes.php">Classes</a></th> 
                    <th class="open">Propriedades de Objecto</th>
                    <th><a href="individuals.php">Indivduos</a></th>
                </tr>
                <tr>
                    <td class="separator" colspan="4">
                        <table class="separator" width="100%">
                            <tr>
                                <td class="left" align="center" valign="top" width="33%"><?php printOPHierarchy();?></td>
                                <td class="right" align="center" valign="top" width="67%"><?php printOPInfo();?></td>
                            </tr>
                        </table>
                    </td>
                </tr>         
            </table>
            
            <br/><br/>
            <h5 class="about">
                <?php
                    // Mostrar quanto tempo esta pgina demorou a gerar:
                    $currentTime = explode(' ', microtime());
                    $totalTime = $currentTime[0] + $currentTime[1] - $startTime;
                    printf('Gerado em %.3fs', $totalTime);
                ?>
                <br />
                &copy;2010 - <a href="about.html">Acerca</a>
            </h5>
        </div>
    </body>
</html>



<?php

    // Mostra a hieraquia de classes
    function printOPHierarchy()
    {
         global $ontology;
         global $reader;
         $ontology = new OWLOntology();
         $reader = new OWLReader();
         $reader->loadFromFile($_SESSION['ontology'], $ontology);
         $reader->inferOPHierarchy($ontology);
         
         print "<table class='secondary' width='100%' height='100%' align='center' bordercolor=#306FA2>";
            print "<tr>";
                print "<td bgcolor='#306FA2'>";
                    print "<b style='color:white'>Hierarquia de propriedades de objecto</b>";
                print "</td>";
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                    print "<ul>";
                        foreach($ontology->getObjectPropertyURIs() as $objectPropertyURI)
                        {
                            // Obter o objecto PHP da propriedade:
                            $objectProperty = $ontology->getObjectProperty($objectPropertyURI);
                            
                            // Mostrar caso esteja no nvel raz:
                            if(count($objectProperty->getSuperPropertyURIs()) == 0)
                                recursivePrint($ontology, $objectProperty);
                        }
                    print "</ul>";
                    print "<br/><b>Total: </b>" . count($ontology->getObjectPropertyURIs());
                    print "<br/>";
                print "</td>";                
            print "</tr>";                   
        print "</table>";               
    }
    
    
    
    // Imprime a hierarquia de propriedades recursivamente:
    function recursivePrint(&$ontology, &$objectProperty)
    {
        // Mostrar dados da classe actual:
        if($objectProperty == null) return;
        else
        {
            $string = " href=object_prop.php?prop=" . utf8_decode($objectProperty->getLabel()) .
                  ">" . utf8_decode($objectProperty->getLabel()) . "</a>";
            
            // Realar caso esteja seleccionada:
            if(strcmp(utf8_decode($objectProperty->getLabel()), $_GET['prop']) == 0)
                $string = "<a class='highlight'" . $string;
            else $string = "<a" . $string;
            
            // Meter a negrito se esta no tiver subpropriedades:
            if(count($objectProperty->getSubPropertyURIs()) > 0) print "<li>" . $string . "</li>";
            else print "<li><b>" . $string . "</b></li>";
        }
        
        // Percorrer as subpropriedades desta:
        foreach($objectProperty->getSubPropertyURIs() as $nextURI)
        {
            // Obter o objecto PHP da propriedade:
            $objectProperty = $ontology->getObjectProperty($nextURI);
            if($objectProperty == null) continue;
            
            print "<ul>";
            recursivePrint($ontology, $objectProperty);
            print "</ul>";
        }
    }
    
    
    
    // Criar formulrio para mostrar informao das propriedades:
    function printOPInfo()
    {
        // Inicializar as variveis todas necessrias:
        global $ontology;
        global $reader;
        $propertyURI = "";
        $propertyLabel = "";
        $subProperties = Array();
        $superProperties = Array();

        // Definir as variveis, caso a classe seja vlida:
        if($_GET['prop'])
        {
            // Obter o objecto desta propriedade:
            $property = $ontology->getObjectProperty($ontology->getNamespace() . utf8_encode($_GET['prop']));
            
            if($property != null)
            {
                // Atribuir variveis:
                $propertyURI = $property->getURI();
                $propertyLabel = $property->getLabel();
                $subProperties = $property->getSubPropertyURIs();
                $superProperties = $property->getSuperPropertyURIs();
            }
        }
        
        // Mostrar todos os dados:
        print "<table width='100%' height='100%' class='secondary' bordercolor=#306FA2>";
            print "<tr>";
                print "<td bgcolor='#306FA2'>";   
                    print "<b style='color:white'>Descrio: " . utf8_decode($propertyLabel) . "</b>";
                print "</td>";
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                    print "<b>URI: </b><br/><div class='indent'>" . utf8_decode($propertyURI) . "</div><br/>";
                    print "<b>Super propriedades: </b><br/><div class='indent'>";
                        foreach($superProperties as $superPropertyURI)
                        {
                            $superProperty = $ontology->getObjectProperty($superPropertyURI);
                            print "<a href='object_prop.php?prop=" . utf8_decode($superProperty->getLabel()) . "'>" .
                                  utf8_decode($superProperty->getLabel()) . "</a><br/>";
                        }
                        print "</div><br/>";
                    print "<b>Sub propriedades: </b><br/><div class='indent'>";
                        foreach($subProperties as $subPropertyURI)
                        {
                            $subProperty = $ontology->getObjectProperty($subPropertyURI);
                            print "<a href='object_prop.php?prop=" . utf8_decode($subProperty->getLabel()) . "'>" .
                                  utf8_decode($subProperty->getLabel()) . "</a><br/>";
                        }
                        print "</div><br/>";
                print "</td>";
            print "</tr>";
        print "</table>";
    }
?>