<?php
    session_start();
    
    // Imports da biblioteca phpowl:
    //require_once "./phpowl/OWLClass.php";
    //require_once "./phpowl/OWLOntology.php";
    require_once "./phpowl/OWLReader.php";  
    if(isset($_GET['visualize'])){
        $_SESSION['ontology'] = $_GET['path'];
   }
   if(isset($_GET['erase'])){
       if($_GET['erase']==1){
        $_SESSION['ontology'] = $_GET['path'];  
       }
   }
?>

<html>
    <?php
        // Guardar o tempo actual para mostrar o tempo necessrio para gerar a pgina:
        $startTime = explode(' ', microtime());
        $startTime = $startTime[1] + $startTime[0];
    ?>

    <!-- HTML CSS Definitions -->
    <head><link rel="stylesheet" type="text/css" href="css/style.css" />
        <style type="text/css"></style>
        <title>Ontology Navigator</title>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
    </head>

    <!-- BODY -->
    <body>
        <div align="center">
            <a href="index.php"> <img border="0" height="25%" alt="OWL Navigator" src="images/logo6.png"/></a>
            <br/><br/>
            <br style="font-size:50%;"/>
            <br style="font-size:50%;"/>
            <table class="main">
                <tr>
                    <th class="open">Viso Geral</th>
                    <th><a href="classes.php">Classes</a></th> 
                    <th><a href="object_prop.php">Propriedades de Objecto</a></th> 
                    <th><a href="individuals.php">Indivduos</a></th>
                </tr>
                <tr>
                    <td class="select" bgcolor='#F2F2F2' colspan="4"><?php printInfo();?></td>
                </tr>
                <tr>
                    <td class="separatorB" colspan="4">
                        <table class="separator" width="100%">
                            <tr>
                                <td class="left" align="center" valign="top" width="33%"><?php printClasses();?></td>
                                <td class="middle" align="center" valign="top" width="33%"><?php printObjects();?></td>
                                <td class="right" align="center" valign="top" width="33%"><?php printIndividuals();?></td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
            
            <br/><br/>
            <h5 class="about">
                <?php
                    // Mostrar quanto tempo esta pgina demorou a gerar:
                    $currentTime = explode(' ', microtime());
                    $totalTime = $currentTime[0] + $currentTime[1] - $startTime;
                    printf('Gerado em %.3fs', $totalTime);
                ?>
                <br />
                &copy;2010 - <a href="about.html">Acerca</a>
            </h5>
        </div>
    </body>
</html>

<?php

    // Mostra a informao geral
    function printInfo() {
             $ontology = new OWLOntology();
             $reader = new OWLReader();
             $reader->loadFromFile($_SESSION['ontology'], $ontology);
 
         print "<b>URL do Ficheiro: </b>" . $ontology->getPath() . "<br/>";
         print "<b>Tipo de estrutura: </b>";
            if(strcmp($ontology->getOntologyType(), OWLTag::$OWL2) == 0)
                print "OWL/XML";
            elseif(strcmp($ontology->getOntologyType(), OWLTag::$OWL) == 0)
                print "RDF/XML";
            else "?";
            if(strlen($ontology->getOntologyType()) > 0)
                print " (<a href=" . $ontology->getOntologyType() . " target='_blank'>" . $ontology->getOntologyType() . "</a>)";
            print "<br/>";
         print "<b>Nome interno: </b>" . utf8_decode($ontology->getName()) . "<br/>";
         print "<b>Namespace: </b>" . $ontology->getNamespace() . "<br/>";  
         print "<b>Comentrio: </b>" . utf8_decode($ontology->getComment()) . "<br/>";
    }
    
    
      
    // Mostra as classes
    function printClasses() {
         $ontology = new OWLOntology();
         $reader = new OWLReader();
         $reader->loadFromFile($_SESSION['ontology'], $ontology);
                    
        print "<table class='secondary' width='100%' height='100%' align='center' bordercolor=#CC9F2A>";
            print "<tr>";
                print "<td bgcolor='#CC9F2A'>";
                    print "<b style='color:white'>Classes</b>";
                print "</td>";   
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                print "<ul>";
                        // Mostrar s as primeiras 10 classes seguido de (...) a apontar para o separador classes
                        $counter=0;
                        foreach($ontology->getClassURIs() as $classURI) {
                        $counter++;
                            print "<li><a class='secondary' href=classes.php?class=" . utf8_decode($ontology->getClass($classURI)->getLabel()) . ">" . utf8_decode($ontology->getClass($classURI)->getLabel()) . "</a></li>";
                            if ( $counter == 10 ) {
                                print "<li><a href='classes.php'><b>(...)</b></a></th></li>";   
                            break;
                            } 
                        }
                print "</ul>";
                print "<br/><b>Total: </b>" . count($ontology->getClassURIs());
                print "</td>";
                 
            print "</tr>";                   
        print "</table>"; 
    }
    
 
    // Mostra as propriedades dos objectos  
    function printObjects() {
         $ontology = new OWLOntology();
         $reader = new OWLReader();
         $reader->loadFromFile($_SESSION['ontology'], $ontology);
            
        print "<table class='secondary' width='100%' height='100%' bordercolor=#306FA2>";
            print "<tr>";
                print "<td bgcolor='#306FA2'>";
                    print "<b style='color:white'>Propriedades de Objecto</b>";
                print "</td>";   
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                        // Mostrar s as primeiras 10 propr. objectos seguido de (...) a apontar para o separador propriedades de objecto
                        print "<ul>";
                        $counter=0;                
                        foreach($ontology->getObjectPropertyURIs() as $propertyURI) {
                        $counter++;
                            print "<li><a class='secondary' href=object_prop.php?prop=" . utf8_decode($ontology->getObjectProperty($propertyURI)->getLabel()) . ">" . utf8_decode($ontology->getObjectProperty($propertyURI)->getLabel()) . "</a></li>";
                            if ( $counter == 10 ) {
                                print "<li><a href='object_prop.php'><b>(...)</b></a></th></li>";   
                            break;
                            }
                        }
                print "</ul>";                             
                print "<br/><b>Total: </b>" . count($ontology->getObjectPropertyURIs());
                print "</td>";   
            print "</tr>";                   
        print "</table>"; 
    }
    
    
        
    // Mostra os indivduos 
    function printIndividuals() {
         $ontology = new OWLOntology();
         $reader = new OWLReader();
         $reader->loadFromFile($_SESSION['ontology'], $ontology);
            
        print "<table class='secondary' width='100%' height='100%' bordercolor=#531852>";
            print "<tr>";
                print "<td bgcolor='#531852'>";
                    print "<b style='color:white'>Indivduos</b>";
                print "</td>";   
            print "</tr>";
            print "<tr>";
                print "<td class='data'>";
                        // Mostrar s os primeiras 10 indivduos seguido de (...) a apontar para o separador indivduos
                        print "<ul>";
                        $counter=0;                
                        foreach($ontology->getIndividualURIs() as $individualURI) {
                        $counter++;
                            print "<li><a class='secondary' href=individuals.php?indv=" . utf8_decode($ontology->getIndividual($individualURI)->getLabel()) . ">" . utf8_decode($ontology->getIndividual($individualURI)->getLabel()) . "</a></li>";
                            if ( $counter == 10 ) {
                                print "<li><a href='individuals.php'><b>(...)</b></a></th></li>";   
                            break;
                            }
                        }                  
                    print "</ul>";
                    print "<br/><b>Total: </b>" . count($ontology->getIndividualURIs());
                print "</td>"; 
            print "</tr>";                   
        print "</table>"; 
    }               
?>