<?php
require_once "OWLTag.php";
require_once "OWLClass.php";
require_once "OWLIndividual.php";



/**
 * Definio da tag "ClassAssertion".
 * Subclasse de OWLTag
 * @author Joel Azevedo, n39083
 * @author Diogo Ribeiro, n41567
 * @version 1.0
 */
class OWLClassAssertionTag extends OWLTag
{
    public $classURI;
    public $individualURI;
    
    
    
    /**
     * Constructor.
     * @param OWLOntology $ontology O apontador para onde ser guardada a ontologia.
     * @param OWLTag $currentSuperTag O apontador para a tag de nvel superior. Pode ser <code>null</code>.  
     */
    public function OWLClassAssertionTag(&$ontology, $currentSuperTag)
    {
        parent::OWLTag($ontology, $currentSuperTag);
        
        $this->classURI = null;
        $this->individualURI = null;
        
        return $this;
    }
    
    
    
    /**
     * Manipulador de fim de tag.
     * @param resource $parser A referncia do parser XML.
     * @param string $name O nome do elemento.                            
     */
    public function closeTag($parser, $name)
    {
        if($this->currentSubTag != null)
        {
            $this->currentSubTag->closeTag($parser, $name);
            if($this->currentSubTag->isOpen() == false)
                $this->currentSubTag = null;
        }
        else
        {
            // Definir variveis desta tag:
            $this->isTagOpen = false;
            
            // DEBUG --- \/
            if(OWLReader::$DEBUG) {
                print "(ClassAssrt)";
                for($obj = $this->currentSuperTag->currentSuperTag; $obj != null;
                    $obj = $obj->currentSuperTag) print "|  ";
                print "[CLOSE] NAME=\"" . $name . "<br/>";
            }
            // DEBUG --- /\
            
            // Verificar o tipo de tag:
            if(strcmp($this->currentTagName, OWLTag::$OWL2_CLASSASSERTION) == 0)
            {
                if($this->individualURI != null &&
                   $this->classURI != null)
                {
                    // Armazenar esta relao na ontologia para mais tarde inferir, se necessrio.
                    if(!is_array($this->ontology->_members[$this->individualURI]))
                        $this->ontology->_members[$this->individualURI] = array();
                    array_push($this->ontology->_members[$this->individualURI], $this->classURI);
                }
            }
            else
            {
                // Tag "OWLClassAssertion" no suportada...
            }
        }
    }
}
?>