<?php
require_once "OWLTag.php";



/**
 * Definio da tag "Constant".
 * Subclasse de OWLTag
 * @author Joel Azevedo, n39083
 * @author Diogo Ribeiro, n41567
 * @version 1.0
 */
class OWLConstantTag extends OWLTag
{
    /**
     * Constructor.
     * @param OWLOntology $ontology O apontador para onde ser guardada a ontologia.
     * @param OWLTag $currentSuperTag O apontador para a tag de nvel superior. Pode ser <code>null</code>.  
     */
    public function OWLConstantTag(&$ontology, $currentSuperTag)
    {
        parent::OWLTag($ontology, $currentSuperTag);
        
        return $this;
    }
    
    
    
    /**
     * Manipulador de texto no interior das tags.
     * @param resource $parser A referncia do parser XML.
     * @param string $data O texto no interior da tag.
     */
    public function data($parser, $data)
    {
        if($this->currentSubTag != null)
            $this->currentSubTag->data($parser, $data);
        else
        {
            // DEBUG --- \/
            if(OWLReader::$DEBUG && strlen(trim($data)) != 0) {
                print "(Constant)  ";
                for($obj = $this->currentSuperTag; $obj != null;
                    $obj = $obj->currentSuperTag) print "|  ";
                print "[CHAR] DATA=\"" . trim($data) . "\"<br/>";
            }
            // DEBUG --- /\
            
            // Verificar se este  um comentrio em OWL/XML acerca de uma ontologia:
            if(strcmp($this->currentTagName, OWLTag::$OWL2_CONSTANT) == 0 &&
               strcmp($this->currentSuperTag->currentTagName, OWLTag::$OWL2_ANNOTATION) == 0 &&
               strcmp($this->currentSuperTag->currentSuperTag->currentTagName, OWLTag::$OWL2_ONTOLOGY) == 0)
                $this->ontology->setComment(trim($data));
        }
    }
}
?>